:BasicUpstart2(main)

.label border_color = $d020
.label background_color = $d021

.label irq_vector = $0314
.label irq_handler = $ea31

main:
  :background(DARK_GRAY)
  :border(GRAY)
  // Disable IRQ handling
  sei 

  // inject the handler
  lda #<raster_bars_irq
  sta irq_vector
  lda #>raster_bars_irq
  sta irq_vector + 1

  // Enable IRQ handling
  cli

  rts

raster_bars_irq:
  
  :background(BLACK)
  :nops(230)
  :background(DARK_GRAY)

  jmp irq_handler

.macro border(color) {
  lda #color
  sta border_color
}
.macro background(color) {
  lda #color
  sta background_color
}
.macro nops(count) {
  .for (var i = 0; i < count; i++) {
    nop
  } 
}


